/**
Large Assignment 3: Processing and turtle geometry for Tessellation.
Jorge Loredo Duran
jloredo98@unm.edu
Computational Fabrications, CS 591.
Submitted on March 27, 2022
A cool program that tessellates iron man's face.
*/

import processing.pdf.*;
import Turtle.*;
Turtle t;

void setup() {
  size(1000,800);
  background(255, 209, 59);
  strokeWeight(10);
  t = new Turtle(this);
  noLoop();
}

void draw() {
  
  float size = 50;
  int red = 50;
  int blue = 0;
  int green = 0;
  //positioning the turtle
  t.penUp();
  t.right(180);
  t.forward(400);
  t.right(90);
  t.forward(498);
  t.right(90);
  //forloop for tessellating horizontally
  for (int i = 0; i < 18; i++) {
    //forloop for tessellating vertically
    for (int j = 0; j < 20; j++) {
      Tessellate(size, red, blue, green);
      if (red < 250) {
      red += 20;
      }
      else {
      red = 0;
      }
    }
    t.right(180);
    t.forward(1000);
    t.left(90);
    t.forward(size+8.5);
    t.left(90);
  }
}

 /*FUNCTION THAT DRAWS THE TESSELLATION*/
void Tessellate(float size, int red, int blue, int green) {
    stroke(red, blue, green);
    t.penDown();
    t.forward(size);
    t.right(135);
    t.forward(30);
    t.left(45);
    t.forward(7.5);
    t.left(45);
    t.forward(30);
    t.right(135);
    t.forward(size);
    t.right(45);
    t.forward(30);
    t.right(45);
    t.forward(7.5);
    t.right(45);
    t.forward(30);
    t.right(45);
    //Drwawing the eyes
    drawEyes(size);
    //drawing the mouth
    drawMouth(size);
    
}

void drawEyes(float size) {
  t.penUp();
  t.forward(size);
  t.right(180);
  t.forward(33);
  t.left(90);
  t.forward(12);
  strokeWeight(5);
  stroke(59, 209, 255);
  t.penDown();
  t.forward(3);
  t.penUp();
  t.forward(20);
  t.penDown();
  t.forward(3);
  t.penUp();
  t.right(180);
  t.forward(38);
  t.right(90);
  t.forward(33);
  strokeWeight(10);
}

void drawMouth(float size) {
  t.right(180);
  t.forward(size);
  t.left(90);
  t.forward(15);
  strokeWeight(2);
  stroke(0,0,0);
  t.penDown();
  t.forward(20);
  t.penUp();
  t.right(180);
  t.forward(35);
  t.right(90);
  t.forward(size);
  strokeWeight(10);
  
}
